<template>
  <b-row align-v="stretch" class="cardRow">
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(0)"
      :size="columnSizes[0]"
      :title="$t('availableapplicationprofiles').toString()"
      @isCollapsing="handleCollapse(0)"
    >
      <APSelection
        :selected-application-profile="applicationProfile"
        :session-stored-application-profiles="sessionStoredApplicationProfiles"
        :token="token"
        @emptyApplicationProfile="emptyApplicationProfile"
        @selectApplicationProfile="selectApplicationProfile"
      />
    </AimsCollapsibleColumn>
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(1)"
      :size="columnSizes[1]"
      :title="$t('metadataForm', { ap: applicationProfileLabel }).toString()"
      @isCollapsing="handleCollapse(1)"
    >
      <MetadataForm
        :complete-application-profile="completeApplicationProfile"
        :metadata="currentMetadata"
        :read-only="readOnly"
        :selected-application-profile="applicationProfile"
        :selected-definition="definition"
        @isValid="isValid"
        @setMetadata="setMetadata"
      />
      <b-row v-if="queriedMetadata.length > 0">
        <b-col cols="auto" class="text-start me-auto">
          <b-button
            variant="secondary"
            @click="
              !readOnly
                ? (currentMetadataIndex = 1)
                : (currentMetadataIndex = 0)
            "
          >
            <i-bi-vector-pen v-if="readOnly" />
            <i-bi-list v-if="!readOnly" />
          </b-button>
        </b-col>
        <b-col cols="auto" align-self="end" class="text-end">
          <b-pagination
            v-if="readOnly"
            v-model="currentMetadataIndex"
            :total-rows="queriedMetadata.length"
            per-page="1"
          ></b-pagination>
        </b-col>
      </b-row>
      <div v-if="canStoreMetadata" class="mt-3">
        <b-button
          class="metadataSearchButton"
          :disabled="storing || readOnly"
          variant="secondary"
          @click="queryWithMetadata('')"
          >{{ $t("Search") }}
        </b-button>
        <b-button
          class="metadataStoreButton"
          :disabled="!valid || storing || readOnly"
          variant="primary"
          @click="storeMetadata"
          >{{ $t("Submit") }}
        </b-button>
        <Teleport to="body">
          <div class="bottom-0 end-0 toast-container position-fixed">
            <b-toast
              id="storingMetadataToast"
              v-model="storingMetadataToastVisible"
              :title="$t('defaultStoringMetadataToastTitle')"
              :auto-hide="false"
            >
              <b-spinner small label="Storing"></b-spinner>
              {{ $t("defaultStoringMetadataToastDescription") }}
            </b-toast>
            <b-toast
              id="storeMetadataToast"
              v-model="storeMetadataToastVisible"
              :title="$t('defaultStoreMetadataToastTitle')"
              auto-hide-delay="5000"
            >
              {{ $t("defaultStoreMetadataToastDescription") }}
            </b-toast>
            <b-toast
              id="storeMetadataFailedToast"
              v-model="storeMetadataFailedToastVisible"
              :title="$t('defaultStoreMetadataFailedToastTitle')"
              auto-hide-delay="5000"
              variant="danger"
              body-class="text-bg-light"
            >
              {{ $t("defaultStoreMetadataFailedToastDescription") }}
            </b-toast>
          </div>
        </Teleport>
      </div>
    </AimsCollapsibleColumn>
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(2)"
      :size="columnSizes[2]"
      :title="$t('metadataView').toString()"
      @isCollapsing="handleCollapse(2)"
    >
      <MetadataView :metadata="currentMetadata" />
    </AimsCollapsibleColumn>
  </b-row>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { Dataset, Quad_Object } from "@rdfjs/types";

import { defineComponent, type PropType } from "vue";
import factory from "rdf-ext";

import { useColumns } from "@/util/columnSizes";

const defaultColumnSizes = [3, 5, 4];
const growOrder = [1, 2, 0];

import serviceProvider from "@/util/service-providers/service-provider";

import AimsCollapsibleColumn from "@/components/Layout/AimsCollapsibleColumn.vue";

import type ValidationReport from "rdf-validate-shacl/src/validation-report";
import prefixes from "@zazuko/prefixes/prefixes";
import { getApplicationProfileLabelValue } from "@/util/linkedData";
import type { PredicateObject } from "@/util/service-providers/aims/metadata";

export default defineComponent({
  name: "MetadataEditor",
  components: {
    AimsCollapsibleColumn,
  },
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    completeApplicationProfile: {
      required: true,
      type: Object as PropType<{
        definition: Dataset;
        inheritedParts: Record<
          string,
          {
            applicationProfile: ApplicationProfile;
            definition: Dataset;
          }
        >;
      }>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    sessionStoredApplicationProfiles: {
      required: false,
      default: 0,
      type: Number,
    },
    token: {
      default: "",
      type: String,
    },
  },
  setup() {
    const { collapsedList, columnSizes, handleCollapse } = useColumns(
      defaultColumnSizes,
      growOrder,
      "metadata",
    );
    return { collapsedList, columnSizes, handleCollapse };
  },
  data() {
    return {
      canStoreMetadata: serviceProvider.can_store_metadata,
      currentMetadataIndex: 0,
      metadata: factory.dataset() as unknown as Dataset,
      queriedMetadata: [] as Dataset[],
      storing: false,
      storingMetadataToastVisible: false,
      storeMetadataToastVisible: false,
      storeMetadataFailedToastVisible: false,
      valid: false,
    };
  },
  computed: {
    applicationProfileLabel(): string {
      return this.getApplicationProfileLabelByLocale(
        this.applicationProfile,
        this.definition,
      );
    },
    currentMetadata(): Dataset {
      if (this.currentMetadataIndex === 0) {
        return this.metadata;
      }
      return this.queriedMetadata[this.currentMetadataIndex - 1];
    },
    readOnly(): boolean {
      return this.currentMetadataIndex !== 0;
    },
    targetClass(): Quad_Object {
      for (const targetClass of this.completeApplicationProfile.definition.match(
        factory.namedNode(this.applicationProfile.base_url),
        factory.namedNode(prefixes.sh + "targetClass"),
      )) {
        return targetClass.object;
      }
      for (const targetClass of this.completeApplicationProfile.definition.match(
        factory.namedNode(this.applicationProfile.base_url),
        factory.namedNode(prefixes.rdf + "type"),
        factory.namedNode(prefixes.rdfs + "Class"),
      )) {
        return targetClass.subject;
      }
      for (const targetClass of this.completeApplicationProfile.definition.match(
        null,
        factory.namedNode(prefixes.sh + "targetClass"),
      )) {
        return targetClass.object;
      }
      return factory.namedNode(
        this.applicationProfile.base_url ?? "https://purl.org/coscine/ap/",
      );
    },
  },
  watch: {
    targetClass() {
      this.setView();
    },
  },
  mounted() {
    this.setView();
  },
  methods: {
    emptyApplicationProfile() {
      this.$emit("emptyApplicationProfile");
    },
    getApplicationProfileLabelByLocale(
      applicationProfile: ApplicationProfile,
      definition: Dataset,
    ) {
      return getApplicationProfileLabelValue(
        applicationProfile,
        definition,
        this.$i18n.locale,
      );
    },
    isValid(valid: ValidationReport) {
      this.valid = valid.conforms;
    },
    async queryWithMetadata(query = "") {
      const predicateObjects: PredicateObject[] = [];
      for (const quad of this.metadata) {
        if (
          quad.predicate.value !== prefixes.rdf + "type" &&
          quad.object.value
        ) {
          predicateObjects.push({
            predicate: quad.predicate.value,
            object: quad.object.value,
          });
        }
      }
      await this.queryMetadata(query, predicateObjects);
      if (this.queriedMetadata.length > 0) {
        this.currentMetadataIndex = 1;
      }
    },
    async queryMetadata(query = "", predicateObjects: PredicateObject[] = []) {
      this.queriedMetadata = await serviceProvider.apiConnection.searchMetadata(
        query,
        this.targetClass.value,
        predicateObjects,
      );
    },
    selectApplicationProfile(selectedApplicationProfile: ApplicationProfile) {
      this.$emit("selectApplicationProfile", selectedApplicationProfile);
    },
    setMetadata(metadata: Dataset) {
      if (!this.readOnly) {
        this.metadata = metadata;
      }
    },
    setView() {
      this.metadata = factory.dataset() as unknown as Dataset;
      this.queryMetadata();
    },
    async storeMetadata() {
      if (this.canStoreMetadata) {
        this.storing = true;

        try {
          this.storingMetadataToastVisible = true;

          const worked = await serviceProvider.apiConnection.storeMetadata(
            this.applicationProfile,
            this.metadata,
          );
          if (!worked) {
            throw new Error("Metadata storing failed!");
          }
          this.metadata = factory.dataset() as unknown as Dataset;

          this.storeMetadataToastVisible = true;
        } catch {
          this.storeMetadataFailedToastVisible = true;
        }
        // Without the timeout, the storing toast will not disappear
        setTimeout(() => (this.storingMetadataToastVisible = false), 1);

        await this.queryMetadata();

        this.storing = false;
      }
    },
  },
});
</script>

<style scoped>
.metadataSearchButton {
  float: left;
}
.metadataStoreButton {
  float: right;
}
</style>
